]> ruderich.org/simon Gitweb - config/dotfiles.git/blobdiff - setup.sh
shell/aliases,setup.sh: Move ls color detection to setup.sh.
[config/dotfiles.git] / setup.sh
index 55efa84bb13cadfae3cbef9ea446eff703f5c3b2..44074f0a0767732289e8e808e5cb1a53e2d075d1 100755 (executable)
--- a/setup.sh
+++ b/setup.sh
@@ -43,6 +43,46 @@ chmod 0700 ~/.tmp
 lesskey lesskey
 chmod 0600 ~/.less
 
+# Find the required options to get colored ls output. GNU ls is preferred. See
+# shell/aliases.in for details. Doing this here instead of in shell/aliases
+# speeds up shell starts.
+#
+# Check if colors are available.
+ls --color > /dev/null 2>&1
+if test $? -eq 0; then
+    ls_color=gnu
+else
+    ls -G > /dev/null 2>&1
+    if test $? -eq 0; then
+        ls_color=cli
+    else
+        ls_color=
+    fi
+fi
+# Absolute path to `ls`.
+ls_path=`which ls`
+# GNU ls with colors.
+if test "x$ls_color" = xgnu; then
+    ls_env=
+    ls_color='--color'
+# Normal (BSD) ls with colors.
+elif test "x$ls_color" = xcli; then
+    ls_env='CLICOLOR_FORCE=1'
+    ls_color='-G'
+# Simple ls with no colors.
+else
+    ls_env=
+    ls_color=
+fi
+generate perl shell/aliases \
+    -e 'while (<STDIN>) {
+            s/\bLS_ENV\b/$ARGV[0]/;
+            s/\bLS_PATH\b/$ARGV[1]/;
+            s/\bLS_COLOR\b/$ARGV[2]/;
+            print;
+        }' \
+    "$ls_env" "$ls_path" "$ls_color"
+
 generate cat screenrc .in
 # As screen-256color is not widely supported use it only on machines where the
 # matching terminfo entry is available. This also requires a terminal emulator